package ru.dbotthepony.mc.otm.client;

import com.mojang.blaze3d.systems.RenderSystem;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.screens.DeathScreen;
import net.minecraft.client.gui.screens.InBedChatScreen;
import net.minecraft.client.player.LocalPlayer;
import net.minecraft.network.chat.TranslatableComponent;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.effect.MobEffects;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.player.Player;
import net.minecraftforge.client.event.ScreenEvent;
import net.minecraftforge.client.event.ScreenOpenEvent;
import net.minecraftforge.client.event.RenderGameOverlayEvent;
import net.minecraftforge.client.gui.ForgeIngameGui;
import net.minecraftforge.eventbus.api.EventPriority;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import ru.dbotthepony.mc.otm.OverdriveThatMatters;
import ru.dbotthepony.mc.otm.capability.android.AndroidCapabilityPlayer;
import ru.dbotthepony.mc.otm.capability.android.IAndroidCapability;
import ru.dbotthepony.mc.otm.capability.MatteryCapability;
import ru.dbotthepony.mc.otm.core.Fraction;
import ru.dbotthepony.mc.otm.core.ImpreciseFraction;

import java.util.Optional;
import java.util.Random;

public class AndroidGui {
	private static final Minecraft mc = Minecraft.getInstance();
	private final ForgeIngameGui gui = mc.gui instanceof ForgeIngameGui ? (ForgeIngameGui) mc.gui : null;

	public static final ResourceLocation PLAYER_GUI_LOCATION = new ResourceLocation(OverdriveThatMatters.MOD_ID, "textures/gui/player_gui.png");

	private AndroidCapabilityPlayer last_state;

	private static int known_button_x = -1;
	private static int known_button_y = -1;
	private static Button known_button;
	private static InBedChatScreen known_button_screen;
	private static final Random button_shaker = new Random();

	@SubscribeEvent(priority = EventPriority.NORMAL)
	@SuppressWarnings("unused")
	public void onTick(ScreenEvent.DrawScreenEvent.Pre event) {
		if (known_button_screen != null && known_button == null) {
			for (var widget : known_button_screen.renderables) {
				if (widget instanceof Button btn) {
					known_button_x = btn.x;
					known_button_y = btn.y;
					known_button = btn;
					break;
				}
			}

			if (known_button == null) {
				known_button_screen = null;
			}
		}

		if (known_button_screen != null && known_button_screen != mc.screen) {
			known_button_x = -1;
			known_button_y = -1;
			known_button = null;
			known_button_screen = null;
		}

		if (known_button_screen == null || mc.player == null) {
			return;
		}

		mc.player.getCapability(MatteryCapability.ANDROID).ifPresent(cap -> {
			if (!((AndroidCapabilityPlayer) cap).willBecomeAndroid) {
				known_button.x = known_button_x;
				known_button.y = known_button_y;
				known_button_x = -1;
				known_button_y = -1;
				known_button = null;
				known_button_screen = null;
				return;
			}

			int dispersion = (int) ((10.0 * Math.max(0, ((AndroidCapabilityPlayer) cap).sleep_ticks - 20)) / (AndroidCapabilityPlayer.SLEEP_TICKS_LIMIT - 20));

			known_button.x = known_button_x - dispersion / 2 + (int) (button_shaker.nextDouble() * dispersion);
			known_button.y = known_button_y - dispersion / 2 + (int) (button_shaker.nextDouble() * dispersion);
		});
	}

	@SubscribeEvent(priority = EventPriority.LOWEST)
	@SuppressWarnings("unused")
	public static void onOpenGUI(ScreenOpenEvent event) {
		known_button_x = -1;
		known_button_y = -1;
		known_button = null;
		known_button_screen = null;

		if (mc.player == null)
			return;

		if (event.getScreen() instanceof DeathScreen screen) {
			mc.player.getCapability(MatteryCapability.ANDROID).ifPresent(cap -> {
				if (cap.isAndroid())
					screen.title = new TranslatableComponent("otm.death_reason");
			});
		}

		if (event.getScreen() instanceof InBedChatScreen screen) {
			known_button_screen = screen;

			mc.player.getCapability(MatteryCapability.ANDROID).ifPresent(cap -> {
				if (((AndroidCapabilityPlayer) cap).willBecomeAndroid) {
					known_button_screen = screen;
				}
			});
		}
	}

	private static final Logger LOGGER = LogManager.getLogger();

	@SubscribeEvent(priority = EventPriority.HIGH)
	@SuppressWarnings("unused")
	public void onLayerRenderEvent(RenderGameOverlayEvent.PreLayer event) {
		if (event.getOverlay() != ForgeIngameGui.FOOD_LEVEL_ELEMENT && event.getOverlay() != ForgeIngameGui.AIR_LEVEL_ELEMENT)
			return;

		LocalPlayer ply = mc.player;

		if (ply == null)
			return;

		if (
				ply.getVehicle() instanceof LivingEntity ||
				mc.options.hideGui ||
				!mc.gameMode.canHurtPlayer() ||
				!(mc.getCameraEntity() instanceof Player)
		)
			return;

		Optional<IAndroidCapability> lazy = ply.getCapability(MatteryCapability.ANDROID).resolve();
		AndroidCapabilityPlayer android = null;

		if (lazy.isPresent()) {
			android = (AndroidCapabilityPlayer) lazy.get();
		} else if (!ply.isAlive()) {
			android = last_state;
		}

		if (android != null && android.isAndroid() && mc.gui instanceof ForgeIngameGui gui) {
			event.setCanceled(true);
			last_state = android;

			if (event.getOverlay() == ForgeIngameGui.AIR_LEVEL_ELEMENT) {
				return;
			}

			int y_offset = ply.hasEffect(MobEffects.HUNGER) ? 18 : 0;

			float level;

			if (android.getMaxBatteryLevel().isZero()) {
				level = 0f;
			} else {
				level = android.getBatteryLevel().div(android.getMaxBatteryLevel()).toFloat();

				if (level >= 0.98f)
					level = 1f;
			}

			gui.setupOverlayRenderState(true, false);

			RenderSystem.setShaderColor(1.0F, 1.0F, 1.0F, 1.0F);
			RenderSystem.setShaderTexture(0, PLAYER_GUI_LOCATION);

			int width = event.getWindow().getGuiScaledWidth();
			int height = event.getWindow().getGuiScaledHeight();

			int left = width / 2 + 10;
			int top = height - gui.right_height;

			gui.right_height += 10;

			// Stack, x, y, blitOffset?, (float) image_x, (float) image_y, rect_x, rect_y, total_image_width, total_image_height
			// Stack, x, y, image_x, image_y, rect_x, rect_y
			gui.blit(event.getMatrixStack(), left, top, 0, y_offset, 80, 9);

			int shift_left = (int) Math.ceil(level * 79f - 0.5f);
			gui.blit(event.getMatrixStack(), left + 79 - shift_left, top, 79 - shift_left, y_offset + 9, shift_left, 9);
		}
	}
}
