package ru.dbotthepony.mc.otm.client.model;

import net.minecraft.client.model.HumanoidModel;
import net.minecraft.client.model.geom.ModelLayerLocation;
import net.minecraft.client.model.geom.PartPose;
import net.minecraft.client.model.geom.builders.*;
import net.minecraftforge.client.ForgeHooksClient;
import ru.dbotthepony.mc.otm.registry.MNames;

public class GravitationStabilizerModel {
	public static final ModelLayerLocation LAYER_LOCATION = new ModelLayerLocation(MNames.PORTABLE_GRAVITATION_STABILIZER, "main");

	private static HumanoidModel<?> model;
	private static LayerDefinition def;

	public static HumanoidModel<?> getModel() {
		if (model == null) {
			return model = new HumanoidModel<>(def.bakeRoot());
		}

		return model;
	}

	public static LayerDefinition createBodyLayer() {
		MeshDefinition meshdefinition = new MeshDefinition();
		PartDefinition partdefinition = meshdefinition.getRoot();

		partdefinition.addOrReplaceChild("right_leg", CubeListBuilder.create(), PartPose.offset(0.0F, 0.0F, 0.0F));
		partdefinition.addOrReplaceChild("left_leg", CubeListBuilder.create(), PartPose.offset(0.0F, 0.0F, 0.0F));
		partdefinition.addOrReplaceChild("head", CubeListBuilder.create(), PartPose.offset(0.0F, 0.0F, 0.0F));
		partdefinition.addOrReplaceChild("hat", CubeListBuilder.create(), PartPose.offset(0.0F, 0.0F, 0.0F));

		model = null;
		return def = LayerDefinition.create(meshdefinition, 64, 64);
	}

	public static void register() {
		ForgeHooksClient.registerLayerDefinition(LAYER_LOCATION, GravitationStabilizerModel::createBodyLayer);
	}
}
