package ru.dbotthepony.mc.otm.menu.data;

import net.minecraft.client.Minecraft;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraftforge.network.NetworkEvent;

import java.util.function.Supplier;

public record ClearPacket(int id) {
	public void write(FriendlyByteBuf buffer) {
		buffer.writeInt(id);
	}

	public static ClearPacket read(FriendlyByteBuf buffer) {
		return new ClearPacket(buffer.readInt());
	}

	public void play(Supplier<NetworkEvent.Context> context) {
		context.get().setPacketHandled(true);
		context.get().enqueueWork(() -> {
			var get = Minecraft.getInstance().player.containerMenu instanceof INetworkedItemViewSupplier supplier && Minecraft.getInstance().player.containerMenu.containerId == id ? supplier.getNetworkedItemView() : null;

			if (get == null) {
				throw new IllegalStateException("No such item tracker with id " + id);
			}

			get.clear();
		});
	}
}
