package ru.dbotthepony.mc.otm.network.android;

import net.minecraft.client.Minecraft;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.fml.DistExecutor;
import net.minecraftforge.network.NetworkEvent;
import ru.dbotthepony.mc.otm.capability.MatteryCapability;
import ru.dbotthepony.mc.otm.core.Fraction;
import ru.dbotthepony.mc.otm.core.ImpreciseFraction;
import ru.dbotthepony.mc.otm.network.NetworkHelper;

import java.math.BigDecimal;
import java.util.function.Supplier;

public record AndroidEnergyPacket(boolean is_maximal, ImpreciseFraction energy) {
	public void write(FriendlyByteBuf buffer) {
		buffer.writeBoolean(is_maximal);
		energy.write(buffer);
	}

	public void play(Supplier<NetworkEvent.Context> context) {
		context.get().setPacketHandled(true);
		context.get().enqueueWork(() -> {
			DistExecutor.unsafeRunWhenOn(Dist.CLIENT, () -> this::playClient);
		});
	}

	public void playClient() {
		var ply = Minecraft.getInstance().player;

		if (ply != null) {
			ply.getCapability(MatteryCapability.ANDROID).ifPresent(cap -> {
				if (is_maximal) {
					cap.setMaxEnergy(energy);
				} else {
					cap.setEnergy(energy);
				}
			});
		}
	}

	public static AndroidEnergyPacket read(FriendlyByteBuf buffer) {
		return new AndroidEnergyPacket(buffer.readBoolean(), ImpreciseFraction.read(buffer));
	}
}
