package ru.dbotthepony.mc.otm.registry;

import net.minecraftforge.event.RegistryEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import ru.dbotthepony.mc.otm.android.AndroidFeature;
import ru.dbotthepony.mc.otm.android.AndroidFeatureType;
import ru.dbotthepony.mc.otm.android.feature.AndroidExtendedReach;
import ru.dbotthepony.mc.otm.android.feature.AndroidLimbOverclocking;
import ru.dbotthepony.mc.otm.android.feature.AndroidNanobotsArmor;
import ru.dbotthepony.mc.otm.android.feature.AndroidNanobotsRegeneration;

public class AndroidFeatures {
	public static final AndroidFeatureType<AndroidFeature> AIR_BAGS = new AndroidFeatureType<>(AndroidFeature::new);
	public static final AndroidFeatureType<AndroidLimbOverclocking> LIMB_OVERCLOCKING = new AndroidFeatureType<>(AndroidLimbOverclocking::new);
	public static final AndroidFeatureType<AndroidNanobotsRegeneration> NANOBOTS_REGENERATION = new AndroidFeatureType<>(AndroidNanobotsRegeneration::new);
	public static final AndroidFeatureType<AndroidNanobotsArmor> NANOBOTS_ARMOR = new AndroidFeatureType<>(AndroidNanobotsArmor::new);
	public static final AndroidFeatureType<AndroidExtendedReach> EXTENDED_REACH = new AndroidFeatureType<>(AndroidExtendedReach::new);

	static {
		AIR_BAGS.setRegistryName(MNames.AIR_BAGS);
		LIMB_OVERCLOCKING.setRegistryName(MNames.LIMB_OVERCLOCKING);
		NANOBOTS_REGENERATION.setRegistryName(MNames.NANOBOTS_REGENERATION);
		NANOBOTS_ARMOR.setRegistryName(MNames.NANOBOTS_ARMOR);
		EXTENDED_REACH.setRegistryName(MNames.EXTENDED_REACH);
	}

	@SubscribeEvent
	@SuppressWarnings("unused")
	public static void register(final RegistryEvent.Register<AndroidFeatureType<?>> event) {
		event.getRegistry().register(AIR_BAGS);
		event.getRegistry().register(LIMB_OVERCLOCKING);
		event.getRegistry().register(NANOBOTS_REGENERATION);
		event.getRegistry().register(NANOBOTS_ARMOR);
		event.getRegistry().register(EXTENDED_REACH);
	}
}
