package ru.dbotthepony.mc.otm.registry;

import net.minecraft.network.chat.TextComponent;
import net.minecraft.network.chat.TranslatableComponent;
import net.minecraft.resources.ResourceLocation;
import net.minecraftforge.event.RegistryEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import ru.dbotthepony.mc.otm.OverdriveThatMatters;
import ru.dbotthepony.mc.otm.android.AndroidResearchBuilder;
import ru.dbotthepony.mc.otm.android.AndroidResearchType;
import ru.dbotthepony.mc.otm.android.feature.AndroidNanobotsArmor;
import ru.dbotthepony.mc.otm.client.render.SkinElement;

public class AndroidResearch {
	public static final ResourceLocation ICONS = new ResourceLocation(OverdriveThatMatters.MOD_ID, "textures/gui/android_upgrades.png");
	public static final SkinElement ICON_TRANSFER;
	public static final SkinElement ICON_ATTACK_BOOST;
	public static final SkinElement ICON_PLASMA_SHIELD_BOOST;
	public static final SkinElement ICON_CLOAK;
	public static final SkinElement ICON_GRAVITATIONAL_STABILIZER;
	public static final SkinElement ICON_AIR_BAGS;
	public static final SkinElement ICON_JUMP_BOOST;

	public static final SkinElement ICON_FEATHER_FALLING;
	public static final SkinElement ICON_ARC;
	public static final SkinElement ICON_ARROW;
	public static final SkinElement ICON_ARMOR;
	public static final SkinElement ICON_NANOBOTS;
	public static final SkinElement ICON_NIGHT_VISION;
	public static final SkinElement ICON_OXYGEN_SUPPLY;

	public static final SkinElement ICON_PLASMA_SHIELD;
	public static final SkinElement ICON_SHOCKWAVE;
	public static final SkinElement ICON_LIMB_OVERCLOCKING;
	public static final SkinElement ICON_STEP_ASSIST;
	public static final SkinElement ICON_ENDER_TELEPORT;
	public static final SkinElement ICON_WIRELESS_CHARGING;
	public static final SkinElement ICON_UNKNOWN;

	public static final SkinElement ICON_EXTENDED_REACH;

	static {
		int x = 0;
		int y = 0;

		ICON_TRANSFER = new SkinElement(ICONS, x, y, 18, 18, 126, 126);
		x += 18;
		ICON_ATTACK_BOOST = new SkinElement(ICONS, x, y, 18, 18, 126, 126);
		x += 18;
		ICON_PLASMA_SHIELD_BOOST = new SkinElement(ICONS, x, y, 18, 18, 126, 126);
		x += 18;
		ICON_CLOAK = new SkinElement(ICONS, x, y, 18, 18, 126, 126);
		x += 18;
		ICON_GRAVITATIONAL_STABILIZER = new SkinElement(ICONS, x, y, 18, 18, 126, 126);
		x += 18;
		ICON_AIR_BAGS = new SkinElement(ICONS, x, y, 18, 18, 126, 126);
		x += 18;
		ICON_JUMP_BOOST = new SkinElement(ICONS, x, y, 18, 18, 126, 126);

		y += 18;
		x = 0;

		ICON_FEATHER_FALLING = new SkinElement(ICONS, x, y, 18, 18, 126, 126);
		x += 18;
		ICON_ARC = new SkinElement(ICONS, x, y, 18, 18, 126, 126);
		x += 18;
		ICON_ARROW = new SkinElement(ICONS, x, y, 18, 18, 126, 126);
		x += 18;
		ICON_ARMOR = new SkinElement(ICONS, x, y, 18, 18, 126, 126);
		x += 18;
		ICON_NANOBOTS = new SkinElement(ICONS, x, y, 18, 18, 126, 126);
		x += 18;
		ICON_NIGHT_VISION = new SkinElement(ICONS, x, y, 18, 18, 126, 126);
		x += 18;
		ICON_OXYGEN_SUPPLY = new SkinElement(ICONS, x, y, 18, 18, 126, 126);

		y += 18;
		x = 0;

		ICON_PLASMA_SHIELD = new SkinElement(ICONS, x, y, 18, 18, 126, 126);
		x += 18;
		ICON_SHOCKWAVE = new SkinElement(ICONS, x, y, 18, 18, 126, 126);
		x += 18;
		ICON_LIMB_OVERCLOCKING = new SkinElement(ICONS, x, y, 18, 18, 126, 126);
		x += 18;
		ICON_STEP_ASSIST = new SkinElement(ICONS, x, y, 18, 18, 126, 126);
		x += 18;
		ICON_ENDER_TELEPORT = new SkinElement(ICONS, x, y, 18, 18, 126, 126);
		x += 18;
		ICON_WIRELESS_CHARGING = new SkinElement(ICONS, x, y, 18, 18, 126, 126);
		x += 18;
		ICON_UNKNOWN = new SkinElement(ICONS, x, y, 18, 18, 126, 126);

		y += 18;
		x = 0;

		ICON_EXTENDED_REACH = new SkinElement(ICONS, x, y, 18, 18, 126, 126);
		x += 18;
	}

	public static final AndroidResearchType<ru.dbotthepony.mc.otm.android.AndroidResearch> AIR_BAGS =
		new AndroidResearchBuilder()
			.setExperienceCost(18)
			.addFeatureResult(AndroidFeatures.AIR_BAGS)
			.withDescription()
			.withIcon(ICON_AIR_BAGS)
			.build();

	public static final AndroidResearchType<ru.dbotthepony.mc.otm.android.AndroidResearch> EXTENDED_REACH =
		new AndroidResearchBuilder()
			.setExperienceCost(40)
			.addFeatureResult(AndroidFeatures.EXTENDED_REACH)
			.withDescription()
			.withIcon(ICON_EXTENDED_REACH)
			.build();

	public static final AndroidResearchType<ru.dbotthepony.mc.otm.android.AndroidResearch>[] LIMB_OVERCLOCKING = new AndroidResearchType[4];
	public static final AndroidResearchType<ru.dbotthepony.mc.otm.android.AndroidResearch>[] NANOBOTS_REGENERATION = new AndroidResearchType[4];
	public static final AndroidResearchType<ru.dbotthepony.mc.otm.android.AndroidResearch>[] NANOBOTS_ARMOR_STRENGTH = new AndroidResearchType[3];
	public static final AndroidResearchType<ru.dbotthepony.mc.otm.android.AndroidResearch>[] NANOBOTS_ARMOR_SPEED = new AndroidResearchType[3];

	public static final AndroidResearchType<ru.dbotthepony.mc.otm.android.AndroidResearch> NANOBOTS =
		new AndroidResearchBuilder()
			.setExperienceCost(15)
			.withDescription()
			.withIcon(ICON_NANOBOTS)
			.build();

	public static final AndroidResearchType<ru.dbotthepony.mc.otm.android.AndroidResearch> NANOBOTS_ARMOR =
		new AndroidResearchBuilder()
			.setExperienceCost(25)
			.withDescription()
			.addPrerequisite(MNames.NANOBOTS)
			.addFeatureResult(MNames.NANOBOTS_ARMOR)
			.withIcon(ICON_ARMOR)
			.build();

	static {
		AIR_BAGS.setRegistryName(MNames.AIR_BAGS);
		NANOBOTS.setRegistryName(MNames.NANOBOTS);
		NANOBOTS_ARMOR.setRegistryName(MNames.NANOBOTS_ARMOR);
		EXTENDED_REACH.setRegistryName(MNames.EXTENDED_REACH);

		for (int i = 0; i < 4; i++) {
			var limbs = new AndroidResearchBuilder()
				.setExperienceCost(18 + i * 8)
				.withIconText(new TextComponent(String.valueOf(i + 1)))
				.withIcon(ICON_LIMB_OVERCLOCKING)
				.withName(new TranslatableComponent("android_research.overdrive_that_matters.limb_overclocking", i + 1))
				.withDescription(new TranslatableComponent("android_research.overdrive_that_matters.limb_overclocking.description", (i + 1) * 8, (i + 1) * 6))
				.addFeatureResult(MNames.LIMB_OVERCLOCKING, i);

			var regeneration = new AndroidResearchBuilder()
				.setExperienceCost(20 + i * 6)
				.withIconText(new TextComponent(String.valueOf(i + 1)))
				.withIcon(ICON_NANOBOTS)
				.withName(new TranslatableComponent("android_research.overdrive_that_matters.nanobots_regeneration", i + 1))
				.withDescription(
					i > 0 ? new TranslatableComponent("android_research.overdrive_that_matters.nanobots_regeneration.description_improve") : new TranslatableComponent("android_research.overdrive_that_matters.nanobots_regeneration.description"))
				.addFeatureResult(MNames.NANOBOTS_REGENERATION, i);

			if (i > 0) {
				limbs.addPrerequisite(MNames.LIMB_OVERCLOCKING_LIST[i - 1]);
				regeneration.addPrerequisite(MNames.NANOBOTS_REGENERATION_LIST[i - 1]);
			} else {
				regeneration.addPrerequisite(MNames.NANOBOTS);
			}

			LIMB_OVERCLOCKING[i] = limbs.build();
			NANOBOTS_REGENERATION[i] = regeneration.build();
		}

		for (int i = 0; i < 3; i++) {
			final int level = i + 1;

			NANOBOTS_ARMOR_STRENGTH[i] = new AndroidResearchBuilder()
				.setExperienceCost(20 + i * 8)
				.withIconText(new TextComponent(String.valueOf(i + 1)))
				.withIcon(ICON_ARMOR)
				.addPrerequisite(i > 0 ? MNames.NANOBOTS_ARMOR_STRENGTH_LIST[i - 1] : MNames.NANOBOTS_ARMOR)
				.withName(new TranslatableComponent("android_research.overdrive_that_matters.nanobots_armor_strength", i + 1))
				.withDescription(new TranslatableComponent("android_research.overdrive_that_matters.nanobots_armor_strength.description", (i + 1) * 8, (i + 1) * 6))
				.addFeatureResult(MNames.NANOBOTS_ARMOR, 0, (feature) -> {
					if (((AndroidNanobotsArmor) feature).getStrength() < level)
						((AndroidNanobotsArmor) feature).setStrength(level);
				})
				.build();

			NANOBOTS_ARMOR_SPEED[i] = new AndroidResearchBuilder()
				.setExperienceCost(20 + i * 8)
				.withIconText(new TextComponent(String.valueOf(i + 1)))
				.withIcon(ICON_ARMOR)
				.addPrerequisite(i > 0 ? MNames.NANOBOTS_ARMOR_SPEED_LIST[i - 1] : MNames.NANOBOTS_ARMOR)
				.withName(new TranslatableComponent("android_research.overdrive_that_matters.nanobots_armor_speed", i + 1))
				.withDescription(new TranslatableComponent("android_research.overdrive_that_matters.nanobots_armor_speed.description", (i + 1) * 8, (i + 1) * 6))
				.addFeatureResult(MNames.NANOBOTS_ARMOR, 0, (feature) -> {
					if (((AndroidNanobotsArmor) feature).getSpeed() < level)
						((AndroidNanobotsArmor) feature).setSpeed(level);
				})
				.build();
		}

		LIMB_OVERCLOCKING[0].setRegistryName(MNames.LIMB_OVERCLOCKING_1);
		LIMB_OVERCLOCKING[1].setRegistryName(MNames.LIMB_OVERCLOCKING_2);
		LIMB_OVERCLOCKING[2].setRegistryName(MNames.LIMB_OVERCLOCKING_3);
		LIMB_OVERCLOCKING[3].setRegistryName(MNames.LIMB_OVERCLOCKING_4);

		NANOBOTS_ARMOR_SPEED[0].setRegistryName(MNames.NANOBOTS_ARMOR_SPEED_1);
		NANOBOTS_ARMOR_SPEED[1].setRegistryName(MNames.NANOBOTS_ARMOR_SPEED_2);
		NANOBOTS_ARMOR_SPEED[2].setRegistryName(MNames.NANOBOTS_ARMOR_SPEED_3);

		NANOBOTS_ARMOR_STRENGTH[0].setRegistryName(MNames.NANOBOTS_ARMOR_STRENGTH_1);
		NANOBOTS_ARMOR_STRENGTH[1].setRegistryName(MNames.NANOBOTS_ARMOR_STRENGTH_2);
		NANOBOTS_ARMOR_STRENGTH[2].setRegistryName(MNames.NANOBOTS_ARMOR_STRENGTH_3);

		NANOBOTS_REGENERATION[0].setRegistryName(MNames.NANOBOTS_REGENERATION_1);
		NANOBOTS_REGENERATION[1].setRegistryName(MNames.NANOBOTS_REGENERATION_2);
		NANOBOTS_REGENERATION[2].setRegistryName(MNames.NANOBOTS_REGENERATION_3);
		NANOBOTS_REGENERATION[3].setRegistryName(MNames.NANOBOTS_REGENERATION_4);
	}

	@SubscribeEvent
	@SuppressWarnings("unused")
	public static void register(final RegistryEvent.Register<AndroidResearchType<?>> event) {
		event.getRegistry().register(AIR_BAGS);
		event.getRegistry().register(NANOBOTS);
		event.getRegistry().register(NANOBOTS_ARMOR);
		event.getRegistry().register(EXTENDED_REACH);

		event.getRegistry().register(LIMB_OVERCLOCKING[0]);
		event.getRegistry().register(LIMB_OVERCLOCKING[1]);
		event.getRegistry().register(LIMB_OVERCLOCKING[2]);
		event.getRegistry().register(LIMB_OVERCLOCKING[3]);

		event.getRegistry().register(NANOBOTS_ARMOR_SPEED[0]);
		event.getRegistry().register(NANOBOTS_ARMOR_SPEED[1]);
		event.getRegistry().register(NANOBOTS_ARMOR_SPEED[2]);
		event.getRegistry().register(NANOBOTS_ARMOR_STRENGTH[0]);
		event.getRegistry().register(NANOBOTS_ARMOR_STRENGTH[1]);
		event.getRegistry().register(NANOBOTS_ARMOR_STRENGTH[2]);

		event.getRegistry().register(NANOBOTS_REGENERATION[0]);
		event.getRegistry().register(NANOBOTS_REGENERATION[1]);
		event.getRegistry().register(NANOBOTS_REGENERATION[2]);
		event.getRegistry().register(NANOBOTS_REGENERATION[3]);
	}
}
