package ru.dbotthepony.mc.otm.storage;

import ru.dbotthepony.mc.otm.core.Fraction;
import ru.dbotthepony.mc.otm.core.ImpreciseFraction;

import javax.annotation.Nonnull;

public record StorageObjectTuple<T extends IStorageStack>(@Nonnull Class<T> identity, @Nonnull T empty, @Nonnull ImpreciseFraction energyPerOperation) {
	@Override
	public boolean equals(Object obj) {
		if (obj instanceof StorageObjectTuple tuple)
			return tuple.identity == identity;

		return false;
	}

	@Override
	public int hashCode() {
		return identity.hashCode();
	}
}
