package ru.dbotthepony.mc.otm.capability.drive

import net.minecraft.nbt.CompoundTag
import net.minecraft.world.item.Item
import net.minecraft.world.item.ItemStack
import ru.dbotthepony.mc.otm.core.Fraction
import ru.dbotthepony.mc.otm.core.ImpreciseFraction
import ru.dbotthepony.mc.otm.storage.IStorageComponent
import ru.dbotthepony.mc.otm.storage.IStorageStack
import ru.dbotthepony.mc.otm.storage.IStorageTuple
import ru.dbotthepony.mc.otm.storage.ItemStackWrapper
import java.util.*

interface IItemMatteryDrive : IMatteryDrive<ItemStackWrapper> {
	/**
	 * @param item
	 * @return all items belonging to passed class
	 */
	fun findItems(item: Item): Collection<IStorageTuple<ItemStackWrapper>>

	/**
	 * @param stack
	 * @return all items that match this itemstack
	 */
	fun findItems(stack: ItemStack): Collection<IStorageTuple<ItemStackWrapper>>
}

interface IItemViewListener {
	fun addViewItem(stack: ItemStack, id_upstream: UUID)
	fun changeViewItem(id_upstream: UUID, new_count: Int)
	fun removeViewItem(id_upstream: UUID)
}

interface IMatteryDrive<T : IStorageStack> : IStorageComponent<T> {
	val uuid: UUID

	var isDirty: Boolean

	val storedCount: ImpreciseFraction
	val driveCapacity: ImpreciseFraction

	// not extending INBTSerializable to avoid serializing it as forgecaps
	fun serializeNBT(): CompoundTag
	fun deserializeNBT(nbt: CompoundTag)
}
