package ru.dbotthepony.mc.otm.client.screen

import net.minecraft.network.chat.Component
import net.minecraft.network.chat.TranslatableComponent
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.client.screen.panels.*
import ru.dbotthepony.mc.otm.client.screen.widget.PowerGaugePanel
import ru.dbotthepony.mc.otm.client.screen.widget.ProgressGaugePanel
import ru.dbotthepony.mc.otm.menu.MenuChemicalGenerator

class ScreenChemicalGenerator(menu: MenuChemicalGenerator, inventory: Inventory, title: Component) : MatteryScreen<MenuChemicalGenerator>(menu, inventory, title) {
	override fun makeMainFrame(): FramePanel {
		val frame = super.makeMainFrame()!!

		PowerGaugePanel(this, frame, menu.energy, LEFT_MARGIN, GAUGE_TOP_WITH_SLOT)
		SlotPanel(this, frame, menu.batterySlot, LEFT_MARGIN, SLOT_TOP_UNDER_GAUGE)

		val self = this
		val progress = object : ProgressGaugePanel(self, frame, menu.progress, 78f, PROGRESS_ARROW_TOP) {
			override fun makeTooltip(): MutableList<Component> {
				val list = super.makeTooltip()

				list.add(TranslatableComponent("otm.gui.power.burn_time", menu.burnTime.value))

				return list
			}
		}

		progress.flop = true
		SlotPanel(this, frame, menu.residueSlot, 56f, PROGRESS_SLOT_TOP)
		SlotPanel(this, frame, menu.fuelSlot, 104f, PROGRESS_SLOT_TOP)

		return frame
	}
}
