package ru.dbotthepony.mc.otm.client.screen

import net.minecraft.network.chat.Component
import net.minecraft.network.chat.TranslatableComponent
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.client.screen.panels.Dock
import ru.dbotthepony.mc.otm.client.screen.panels.FramePanel
import ru.dbotthepony.mc.otm.client.screen.panels.Label
import ru.dbotthepony.mc.otm.menu.MenuEnergyCounter
import ru.dbotthepony.mc.otm.menu.FormattingHelper

class ScreenEnergyCounter(menu: MenuEnergyCounter, inventory: Inventory, title: Component) : MatteryScreen<MenuEnergyCounter>(menu, inventory, title) {
	override fun makeMainFrame(): FramePanel {
		val frame = super.makeMainFrame()!!

		var label: Label = object : Label(this@ScreenEnergyCounter, frame) {
			override fun tick() {
				super.tick()
				setText(
					TranslatableComponent(
						"otm.item.power.passed",
						FormattingHelper.formatPower(menu.passed.value)
					)
				)
			}
		}

		label.dock = Dock.TOP
		label.setDockMargin(4f, 0f, 0f, 0f)

		label = object : Label(this@ScreenEnergyCounter, frame) {
			override fun tick() {
				super.tick()
				setText(
					TranslatableComponent(
						"otm.item.power.average",
						FormattingHelper.formatPower(menu.average.value)
					)
				)
			}
		}

		label.dock = Dock.TOP
		label.setDockMargin(4f, 0f, 0f, 0f)

		label = object : Label(this@ScreenEnergyCounter, frame) {
			override fun tick() {
				super.tick()
				setText(
					TranslatableComponent(
						"otm.item.power.last_20_ticks",
						FormattingHelper.formatPower(menu.last20Ticks.value)
					)
				)
			}
		}

		label.dock = Dock.TOP
		label.setDockMargin(4f, 0f, 0f, 0f)

		label = object : Label(this@ScreenEnergyCounter, frame) {
			override fun tick() {
				super.tick()
				setText(
					TranslatableComponent(
						"otm.item.power.last_tick",
						FormattingHelper.formatPower(menu.lastTick.value)
					)
				)
			}
		}

		label.dock = Dock.TOP
		label.setDockMargin(4f, 0f, 0f, 0f)

		return frame
	}
}