package ru.dbotthepony.mc.otm.client.screen

import net.minecraft.network.chat.Component
import ru.dbotthepony.mc.otm.menu.MenuMatterDecomposer
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.client.screen.panels.FramePanel
import ru.dbotthepony.mc.otm.client.screen.panels.SlotPanel
import ru.dbotthepony.mc.otm.client.screen.widget.MatterGaugePanel
import ru.dbotthepony.mc.otm.client.screen.widget.PowerGaugePanel
import ru.dbotthepony.mc.otm.client.screen.widget.ProgressGaugePanel

class ScreenMatterDecomposer(p_97741_: MenuMatterDecomposer, p_97742_: Inventory, p_97743_: Component) :
	MatteryScreen<MenuMatterDecomposer>(p_97741_, p_97742_, p_97743_) {

	override fun makeMainFrame(): FramePanel {
		val frame = super.makeMainFrame()!!

		val m = PowerGaugePanel(this, frame, menu.powerWidget, LEFT_MARGIN, GAUGE_TOP_WITH_SLOT)
		MatterGaugePanel(this, frame, menu.matterWidget, LEFT_MARGIN + m.width, GAUGE_TOP_WITH_SLOT)

		SlotPanel(this, frame, menu.batterySlot, LEFT_MARGIN, SLOT_TOP_UNDER_GAUGE)

		SlotPanel(this, frame, menu.input, 56f, PROGRESS_SLOT_TOP)
		ProgressGaugePanel(this, frame, menu.progressWidget, 78f, PROGRESS_ARROW_TOP)
		SlotPanel(this, frame, menu.outputMain, 104f, PROGRESS_SLOT_TOP)
		SlotPanel(this, frame, menu.outputStacking, 122f, PROGRESS_SLOT_TOP)

		return frame
	}
}