package ru.dbotthepony.mc.otm.client.screen

import net.minecraft.network.chat.Component
import ru.dbotthepony.mc.otm.menu.MenuMatterScanner
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.client.screen.panels.FramePanel
import ru.dbotthepony.mc.otm.client.screen.panels.SlotPanel
import ru.dbotthepony.mc.otm.client.screen.widget.PatternGaugePanel
import ru.dbotthepony.mc.otm.client.screen.widget.PowerGaugePanel
import ru.dbotthepony.mc.otm.client.screen.widget.ProgressGaugePanel

class ScreenMatterScanner(p_97741_: MenuMatterScanner, p_97742_: Inventory, p_97743_: Component) :
	MatteryScreen<MenuMatterScanner>(p_97741_, p_97742_, p_97743_) {
	override fun makeMainFrame(): FramePanel {
		val frame = super.makeMainFrame()!!

		val m = PowerGaugePanel(this, frame, menu.powerWidget, LEFT_MARGIN, GAUGE_TOP_WITH_SLOT)
		PatternGaugePanel(this, frame, menu.patterns, LEFT_MARGIN + m.width, GAUGE_TOP_WITH_SLOT)

		SlotPanel(this, frame, menu.batterySlot, LEFT_MARGIN, SLOT_TOP_UNDER_GAUGE)

		ProgressGaugePanel(this, frame, menu.progress, 63f, PROGRESS_ARROW_TOP).flop = true
		SlotPanel(this, frame, menu.input, 93f, PROGRESS_SLOT_TOP)

		return frame
	}
}
