package ru.dbotthepony.mc.otm.menu

import net.minecraft.world.Container
import kotlin.jvm.JvmOverloads
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.block.entity.BlockEntityBatteryBank
import net.minecraft.world.SimpleContainer
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget
import ru.dbotthepony.mc.otm.capability.MatteryCapability
import ru.dbotthepony.mc.otm.orNull
import ru.dbotthepony.mc.otm.registry.MMenus

class MenuBatteryBank @JvmOverloads constructor(
	p_38852_: Int,
	inventory: Inventory,
	tile: BlockEntityBatteryBank? = null,
) : MatteryMenu(MMenus.BATTERY_BANK, p_38852_, inventory, tile) {
	val powerLevel: LevelGaugeWidget
	val containerSlots: Array<BatterySlot>

	init {
		val container: Container = tile?.container ?: SimpleContainer(BlockEntityBatteryBank.CAPACITY)
		powerLevel = LevelGaugeWidget(this, tile?.getCapability(MatteryCapability.ENERGY)?.orNull())
		containerSlots = Array(BlockEntityBatteryBank.CAPACITY) {
			val slot = BatterySlot(container, it)
			addSlot(slot)
			return@Array slot
		}

		addInventorySlots()
	}

	override fun getWorkingSlotStart(): Int {
		return 0
	}

	override fun getWorkingSlotEnd(): Int {
		return BlockEntityBatteryBank.CAPACITY
	}
}
