package ru.dbotthepony.mc.otm.menu

import net.minecraft.world.SimpleContainer
import net.minecraft.world.entity.player.Inventory
import net.minecraft.world.entity.player.Player
import ru.dbotthepony.mc.otm.block.entity.BlockEntityCargoCrate
import ru.dbotthepony.mc.otm.registry.MMenus

class MenuCargoCrate @JvmOverloads constructor(
	p_38852_: Int,
	inventory: Inventory,
	tile: BlockEntityCargoCrate? = null
) : MatteryMenu(MMenus.CARGO_CRATE, p_38852_, inventory, tile) {
	val crateSlots: Array<MatterySlot>

	init {
		val container = tile?.container ?: SimpleContainer(BlockEntityCargoCrate.CAPACITY)

		crateSlots = Array(BlockEntityCargoCrate.CAPACITY) {
			val slot = MatterySlot(container, it)
			addSlot(slot)
			return@Array slot
		}

		tile?.onPlayerOpen()
		addInventorySlots()
	}

	override fun removed(p_38940_: Player) {
		super.removed(p_38940_)
		(tile as? BlockEntityCargoCrate)?.onPlayerClose()
	}

	override fun getWorkingSlotStart(): Int {
		return 0
	}

	override fun getWorkingSlotEnd(): Int {
		return BlockEntityCargoCrate.CAPACITY
	}
}
