package ru.dbotthepony.mc.otm.menu

import kotlin.jvm.JvmOverloads
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.block.entity.BlockEntityEnergyCounter
import ru.dbotthepony.mc.otm.menu.data.ImpreciseFractionDataContainer
import ru.dbotthepony.mc.otm.registry.MMenus

class MenuEnergyCounter @JvmOverloads constructor(
	p_38852_: Int,
	inventory: Inventory,
	tile: BlockEntityEnergyCounter? = null
) : MatteryMenu(MMenus.ENERGY_COUNTER, p_38852_, inventory, tile) {
	@JvmField val passed = ImpreciseFractionDataContainer()
	@JvmField val average = ImpreciseFractionDataContainer()
	@JvmField val last20Ticks = ImpreciseFractionDataContainer()
	@JvmField val lastTick = ImpreciseFractionDataContainer()

	// TODO: Graph and proper networking for it
	private var ticksPassed = 0

	init {
		addDataSlots(passed)
		addDataSlots(average)
		addDataSlots(last20Ticks)
		addDataSlots(lastTick)
	}

	override fun broadcastChanges() {
		if (tile is BlockEntityEnergyCounter) {
			passed.value = tile.passed
			average.value = tile.calcAverage(20)
			lastTick.value = tile.lastTick

			if (ticksPassed == 0) {
				last20Ticks.value = tile.sumHistory(20)
			}

			ticksPassed = (ticksPassed + 1) % 20
		}

		super.broadcastChanges()
	}

	override fun getWorkingSlotStart(): Int {
		return 0
	}

	override fun getWorkingSlotEnd(): Int {
		return 0
	}
}