package ru.dbotthepony.mc.otm.menu

import net.minecraft.world.inventory.MenuType
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.block.entity.BlockEntityMatteryPowered
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget
import ru.dbotthepony.mc.otm.capability.MatteryCapability
import net.minecraft.world.SimpleContainer

abstract class MenuMatteryPowered protected constructor(
	menuType: MenuType<*>,
	containerID: Int,
	inventory: Inventory,
	tile: BlockEntityMatteryPowered? = null
) : MatteryMenu(menuType, containerID, inventory, tile) {
	@JvmField val powerWidget: LevelGaugeWidget
	@JvmField val batterySlot: BatterySlot

	init {
		if (tile == null) {
			powerWidget = LevelGaugeWidget(this)
			batterySlot = BatterySlot(SimpleContainer(1), 0)
		} else {
			powerWidget = LevelGaugeWidget(this, tile.energy)
			batterySlot = BatterySlot(tile.batteryContainer, 0)
		}

		addSlot(batterySlot)
	}
}
