package ru.dbotthepony.mc.otm.menu

import net.minecraft.world.SimpleContainer
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.block.entity.BlockEntityPlatePress
import ru.dbotthepony.mc.otm.menu.widget.ProgressGaugeWidget
import ru.dbotthepony.mc.otm.registry.MMenus

class MenuPlatePress @JvmOverloads constructor(
	containerID: Int,
	inventory: Inventory,
	tile: BlockEntityPlatePress? = null
) : MenuMatteryPowered(MMenus.PLATE_PRESS, containerID, inventory, tile) {
	val container = tile?.container ?: SimpleContainer(2)

	val inputSlot = MatterySlot(container, BlockEntityPlatePress.SLOT_INPUT)
	val outputSlot = MachineOutputSlot(container, BlockEntityPlatePress.SLOT_OUTPUT)

	val progressGauge = if (tile != null) ProgressGaugeWidget(this, tile::workProgress, tile::isUnableToProcess) else ProgressGaugeWidget(this)

	init {
		addSlot(inputSlot)
		addSlot(outputSlot)
		addInventorySlots()
	}

	override fun getWorkingSlotStart() = 0
	override fun getWorkingSlotEnd() = 2
}
